diff --git a/tests/TestSuite_dcf_lifecycle.py b/tests/TestSuite_dcf_lifecycle.py
index cd7e1824..28ee99f7 100644
--- a/tests/TestSuite_dcf_lifecycle.py
+++ b/tests/TestSuite_dcf_lifecycle.py
@@ -604,6 +604,10 @@ class TestDcfLifeCycle(TestCase):
             self.verify(expected_str in dmesg_output, msg)
 
     def verify_support_dcf_mode_03(self):
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         except_content = None
         try:
             self.vf_set_trust(vf_id=1)
@@ -646,6 +650,10 @@ class TestDcfLifeCycle(TestCase):
             self.verify(expected_str in dmesg_output, msg)
 
     def verify_support_dcf_mode_04(self):
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         except_content = None
         try:
             self.vf_set_trust_off()
@@ -1089,7 +1097,10 @@ class TestDcfLifeCycle(TestCase):
         """
         Run before each test case.
         """
-        pass
+        # get os kernel version
+        self.os_kernel_version = ".".join(
+            self.dut.send_expect("uname -r", "# ").split(".")[0:2]
+        )
 
     def tear_down(self):
         """
@@ -1182,6 +1193,10 @@ class TestDcfLifeCycle(TestCase):
         """
         When ADQ set on PF, PF should reject the DCF mode
         """
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         msg = "begin : When ADQ set on PF, PF should reject the DCF mode"
         self.logger.info(msg)
         self.verify_dcf_with_adq_01()
@@ -1190,6 +1205,10 @@ class TestDcfLifeCycle(TestCase):
         """
         When DCF mode enabled, ADQ setting on PF shall fail
         """
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         msg = "begin : When DCF mode enabled, ADQ setting on PF shall fail"
         self.logger.info(msg)
         self.verify_dcf_with_adq_02()
@@ -1215,6 +1234,10 @@ class TestDcfLifeCycle(TestCase):
         """
         When DCF mode enabled, PF can't set L2 forwarding
         """
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         msg = "begin : When DCF mode enabled, PF can't set L2 forwarding"
         self.logger.info(msg)
         self.verify_dcf_with_l2fwd_02()
@@ -1513,6 +1536,10 @@ class TestDcfLifeCycle(TestCase):
         self.run_test_post()
 
     def test_dcf_with_acl_filter_01(self):
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         msg = "begin : add ACL rule by kernel, reject request for DCF functionality"
         self.logger.info(msg)
         self.vf_set_trust()
@@ -1555,6 +1582,10 @@ class TestDcfLifeCycle(TestCase):
         self.d_con(["quit", "# ", 15])
 
     def test_dcf_with_acl_filter_02(self):
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         msg = "begin : add ACL rule by kernel, accept request for DCF functionality of another PF"
         self.logger.info(msg)
         self.vf_set_trust()
@@ -1568,6 +1599,10 @@ class TestDcfLifeCycle(TestCase):
         self.d_con(["quit", "# ", 15])
 
     def test_dcf_with_acl_filter_03(self):
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         msg = "begin : ACL DCF mode is active, add ACL filters by way of host based configuration is rejected"
         self.logger.info(msg)
         self.vf_set_trust()
@@ -1579,6 +1614,10 @@ class TestDcfLifeCycle(TestCase):
         self.delete_acl_rule_by_kernel_cmd()
 
     def test_dcf_with_acl_filter_04(self):
+        self.skip_case(
+            self.os_kernel_version > "4.19",
+            "Host kernel version is required 4.19+",
+        )
         msg = "begin : ACL DCF mode is active, add ACL filters by way of host based configuration on another PF successfully"
         self.logger.info(msg)
         self.vf_set_trust()