diff --git a/tests/TestSuite_eeprom_dump.py b/tests/TestSuite_eeprom_dump.py
index c9ffaf1c..669befcd 100644
--- a/tests/TestSuite_eeprom_dump.py
+++ b/tests/TestSuite_eeprom_dump.py
@@ -46,7 +46,11 @@ class TestEEPROMDump(TestCase):
     def dump_to_file(self, regex, get, to, testname):
         # if nic is Intel® Ethernet 800 Series, eeprom_dump get testpmd output of the
         # first 1000 lines, module_eeprom_dump get testpmd output of the first 16 lines.
-        if self.nic in ["ICE_25G-E810C_SFP", "ICE_100G-E810C_QSFP"]:
+        if self.nic in [
+            "ICE_25G-E810C_SFP",
+            "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
+        ]:
             if testname == "eeprom":
                 count = 1000
             elif testname == "module_eeprom":
diff --git a/tests/TestSuite_enable_package_download_in_ice_driver.py b/tests/TestSuite_enable_package_download_in_ice_driver.py
index 05f3915f..afc667e9 100644
--- a/tests/TestSuite_enable_package_download_in_ice_driver.py
+++ b/tests/TestSuite_enable_package_download_in_ice_driver.py
@@ -14,7 +14,12 @@ class TestEnable_Package_Download_In_Ice_Driver(TestCase):
     def set_up_all(self):
         self.verify(
             self.nic
-            in ["ICE_100G-E810C_QSFP", "ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP"],
+            in [
+                "ICE_100G-E810C_QSFP",
+                "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
+                "ICE_25G-E823C_QSFP",
+            ],
             "NIC Unsupported: " + str(self.nic),
         )
         self.dut_ports = self.dut.get_ports(self.nic)
diff --git a/tests/TestSuite_flexible_rxd.py b/tests/TestSuite_flexible_rxd.py
index 06ea96ce..199bbeeb 100644
--- a/tests/TestSuite_flexible_rxd.py
+++ b/tests/TestSuite_flexible_rxd.py
@@ -15,6 +15,7 @@ class TestFlexibleRxd(TestCase, FlexibleRxdBase):
         "ICE_100G-E810C_QSFP",
         "ICE_25G-E810C_SFP",
         "ICE_25G-E810_XXV_SFP",
+        "ICE_25G-E823C_QSFP",
         "IGC-I225_LM",
     ]
 
diff --git a/tests/TestSuite_generic_flow_api.py b/tests/TestSuite_generic_flow_api.py
index 49d6c502..9fadff63 100644
--- a/tests/TestSuite_generic_flow_api.py
+++ b/tests/TestSuite_generic_flow_api.py
@@ -1090,6 +1090,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_10G-SFP_X722",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support 2-tuple filter" % self.nic,
         )
@@ -1113,6 +1114,7 @@ class TestGeneric_flow_api(TestCase):
             "I40E_10G-SFP_X722",
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
         ]:
             basic_flow_actions = [
                 {
@@ -1206,6 +1208,7 @@ class TestGeneric_flow_api(TestCase):
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support ethertype filter" % self.nic,
         )
@@ -1230,6 +1233,7 @@ class TestGeneric_flow_api(TestCase):
             "I40E_10G-10G_BASE_T_X722",
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
         ]:
 
             basic_flow_actions = [
@@ -1325,6 +1329,7 @@ class TestGeneric_flow_api(TestCase):
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir L2 payload filter" % self.nic,
         )
@@ -1393,6 +1398,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir vlan filter" % self.nic,
         )
@@ -1525,6 +1531,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir vlan filter" % self.nic,
         )
@@ -1659,6 +1666,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir vlan filter" % self.nic,
         )
@@ -1793,6 +1801,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir vlan filter" % self.nic,
         )
@@ -1937,6 +1946,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir vlan filter" % self.nic,
         )
@@ -2272,6 +2282,7 @@ class TestGeneric_flow_api(TestCase):
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir vlan filter" % self.nic,
         )
@@ -2595,6 +2606,7 @@ class TestGeneric_flow_api(TestCase):
                 "IXGBE_10G-82599_SFP",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
                 "IXGBE_10G-X550EM_X_10G_T",
                 "IXGBE_10G-X550T",
                 "I40E_10G-SFP_XL710",
@@ -2616,6 +2628,7 @@ class TestGeneric_flow_api(TestCase):
             "I40E_40G-QSFP_A",
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
             "I40E_40G-QSFP_B",
             "I40E_10G-SFP_X722",
             "I40E_10G-10G_BASE_T_X722",
@@ -3235,6 +3248,7 @@ class TestGeneric_flow_api(TestCase):
                 "IXGBE_10G-X550T",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
                 "I40E_10G-SFP_XL710",
                 "I40E_25G-25G_SFP28",
                 "I40E_40G-QSFP_A",
@@ -3254,6 +3268,7 @@ class TestGeneric_flow_api(TestCase):
             "I40E_40G-QSFP_A",
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
             "I40E_40G-QSFP_B",
             "I40E_10G-SFP_X722",
             "I40E_10G-10G_BASE_T_X722",
@@ -4136,6 +4151,7 @@ class TestGeneric_flow_api(TestCase):
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir flexbytes filter" % self.nic,
         )
@@ -4150,6 +4166,7 @@ class TestGeneric_flow_api(TestCase):
             "I40E_10G-10G_BASE_T_X722",
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
         ]:
             self.pmdout.start_testpmd(
                 "%s" % self.pf_cores,
@@ -4730,6 +4747,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_10G-SFP_X722",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support fdir mac vlan filter" % self.nic,
         )
@@ -4754,6 +4772,7 @@ class TestGeneric_flow_api(TestCase):
             "I40E_10G-SFP_X722",
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
         ]:
             basic_flow_actions = [
                 {"create": "validate", "flows": ["vlan"], "actions": ["queue"]},
@@ -4799,6 +4818,7 @@ class TestGeneric_flow_api(TestCase):
                 "IXGBE_10G-X550T",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
                 "IGC-I225_LM",
                 "IGC-I226_LM",
             ],
@@ -4999,6 +5019,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_40G-QSFP_A",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
                 "I40E_40G-QSFP_B",
                 "I40E_10G-SFP_X722",
                 "I40E_10G-10G_BASE_T_X722",
@@ -5265,6 +5286,7 @@ class TestGeneric_flow_api(TestCase):
                 "I40E_40G-QSFP_A",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
                 "I40E_40G-QSFP_B",
                 "I40E_10G-SFP_X722",
                 "I40E_10G-10G_BASE_T_X722",
diff --git a/tests/TestSuite_iavf_flexible_descriptor.py b/tests/TestSuite_iavf_flexible_descriptor.py
index 8fe8fe0e..f4e689cd 100644
--- a/tests/TestSuite_iavf_flexible_descriptor.py
+++ b/tests/TestSuite_iavf_flexible_descriptor.py
@@ -15,6 +15,7 @@ class TestIavfFlexibleDescriptor(TestCase, FlexibleRxdBase):
         "ICE_100G-E810C_QSFP",
         "ICE_25G-E810C_SFP",
         "ICE_25G-E810_XXV_SFP",
+        "ICE_25G-E823C_QSFP",
         "IGC-I225_LM",
     ]
 
diff --git a/tests/TestSuite_iavf_package_driver_error_handle.py b/tests/TestSuite_iavf_package_driver_error_handle.py
index da4f1ea7..a3e4e9a9 100644
--- a/tests/TestSuite_iavf_package_driver_error_handle.py
+++ b/tests/TestSuite_iavf_package_driver_error_handle.py
@@ -16,7 +16,12 @@ class Testiavf_package_and_driver_check(TestCase):
     def set_up_all(self):
         self.verify(
             self.nic
-            in ["ICE_100G-E810C_QSFP", "ICE_25G-E810_XXV_SFP", "ICE_25G-E810C_SFP"],
+            in [
+                "ICE_100G-E810C_QSFP",
+                "ICE_25G-E810_XXV_SFP",
+                "ICE_25G-E810C_SFP",
+                "ICE_25G-E823C_QSFP",
+            ],
             "NIC Unsupported: " + str(self.nic),
         )
         self.dut_ports = self.dut.get_ports(self.nic)
diff --git a/tests/TestSuite_ice_advanced_rss_gtpu.py b/tests/TestSuite_ice_advanced_rss_gtpu.py
index d2186645..a5bb34be 100644
--- a/tests/TestSuite_ice_advanced_rss_gtpu.py
+++ b/tests/TestSuite_ice_advanced_rss_gtpu.py
@@ -5059,7 +5059,12 @@ mac_ipv4_gtpu_eh_ipv6_tcp_without_ul_dl_symmetric = eval(
 
 
 class TestICEAdvancedRSSGTPU(TestCase):
-    supported_nic = ["ICE_100G-E810C_QSFP", "ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP"]
+    supported_nic = [
+        "ICE_100G-E810C_QSFP",
+        "ICE_25G-E810C_SFP",
+        "ICE_25G-E810_XXV_SFP",
+        "ICE_25G-E823C_QSFP",
+    ]
 
     @check_supported_nic(supported_nic)
     @skip_unsupported_pkg("os default")
diff --git a/tests/TestSuite_ice_buffer_split.py b/tests/TestSuite_ice_buffer_split.py
index bde1ca0d..55d37ec6 100644
--- a/tests/TestSuite_ice_buffer_split.py
+++ b/tests/TestSuite_ice_buffer_split.py
@@ -521,7 +521,8 @@ class TestBufferSplit(TestCase):
         Generic filter Prerequistites
         """
         self.verify(
-            self.nic in ["ICE_25G-E810C_SFP", "ICE_100G-E810C_QSFP"],
+            self.nic
+            in ["ICE_25G-E810C_SFP", "ICE_100G-E810C_QSFP", "ICE_25G-E823C_QSFP"],
             "%s nic not support timestamp" % self.nic,
         )
         self.dut_ports = self.dut.get_ports(self.nic)
diff --git a/tests/TestSuite_ice_dcf_disable_acl_filter.py b/tests/TestSuite_ice_dcf_disable_acl_filter.py
index 74d313e1..788a273a 100644
--- a/tests/TestSuite_ice_dcf_disable_acl_filter.py
+++ b/tests/TestSuite_ice_dcf_disable_acl_filter.py
@@ -71,7 +71,12 @@ subcases = {
 
 
 class ICEDCFACLDisableFilterTest(TestCase):
-    supported_nic = ["ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP", "ICE_100G-E810C_QSFP"]
+    supported_nic = [
+        "ICE_25G-E810C_SFP",
+        "ICE_25G-E810_XXV_SFP",
+        "ICE_100G-E810C_QSFP",
+        "ICE_25G-E823C_QSFP",
+    ]
 
     @check_supported_nic(supported_nic)
     def set_up_all(self):
diff --git a/tests/TestSuite_ice_dcf_switch_filter_pppoe.py b/tests/TestSuite_ice_dcf_switch_filter_pppoe.py
index 5780bc17..38b95122 100644
--- a/tests/TestSuite_ice_dcf_switch_filter_pppoe.py
+++ b/tests/TestSuite_ice_dcf_switch_filter_pppoe.py
@@ -792,7 +792,12 @@ tv_mac_vlan_pppoe_ipcp_pay = {
 
 
 class ICEDCFSwitchFilterPPPOETest(TestCase):
-    supported_nic = ["ICE_100G-E810C_QSFP", "ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP"]
+    supported_nic = [
+        "ICE_100G-E810C_QSFP",
+        "ICE_25G-E810C_SFP",
+        "ICE_25G-E810_XXV_SFP",
+        "ICE_25G-E823C_QSFP",
+    ]
 
     def bind_nics_driver(self, ports, driver=""):
         # modprobe vfio driver
diff --git a/tests/TestSuite_l2tp_esp_coverage.py b/tests/TestSuite_l2tp_esp_coverage.py
index c9aaee5b..480c2240 100644
--- a/tests/TestSuite_l2tp_esp_coverage.py
+++ b/tests/TestSuite_l2tp_esp_coverage.py
@@ -109,7 +109,12 @@ tv_MAC_IPV6_NAT_T_ESP_vlan = {
 
 
 class L2tpEspCoverage(TestCase):
-    supported_nic = ["ICE_100G-E810C_QSFP", "ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP"]
+    supported_nic = [
+        "ICE_100G-E810C_QSFP",
+        "ICE_25G-E810C_SFP",
+        "ICE_25G-E810_XXV_SFP",
+        "ICE_25G-E823C_QSFP",
+    ]
 
     @check_supported_nic(supported_nic)
     def set_up_all(self):
diff --git a/tests/TestSuite_large_vf.py b/tests/TestSuite_large_vf.py
index fb03145e..fb675df3 100644
--- a/tests/TestSuite_large_vf.py
+++ b/tests/TestSuite_large_vf.py
@@ -189,7 +189,12 @@ class TestLargeVf(TestCase):
         self.dut_ports = self.dut.get_ports(self.nic)
         self.verify(
             self.nic
-            in ["ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP", "ICE_100G-E810C_QSFP"],
+            in [
+                "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
+                "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
+            ],
             "%s nic not support large vf" % self.nic,
         )
         self.verify(len(self.dut_ports) >= 1, "Insufficient ports for testing")
diff --git a/tests/TestSuite_multiprocess.py b/tests/TestSuite_multiprocess.py
index 099ce6e7..90d9f0cf 100644
--- a/tests/TestSuite_multiprocess.py
+++ b/tests/TestSuite_multiprocess.py
@@ -31,7 +31,12 @@ executions = []
 
 class TestMultiprocess(TestCase):
 
-    support_nic = ["ICE_100G-E810C_QSFP", "ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP"]
+    support_nic = [
+        "ICE_100G-E810C_QSFP",
+        "ICE_25G-E810C_SFP",
+        "ICE_25G-E810_XXV_SFP",
+        "ICE_25G-E823C_QSFP",
+    ]
 
     def set_up_all(self):
         """
diff --git a/tests/TestSuite_multiprocess_iavf.py b/tests/TestSuite_multiprocess_iavf.py
index c52bfa9c..313bee9d 100644
--- a/tests/TestSuite_multiprocess_iavf.py
+++ b/tests/TestSuite_multiprocess_iavf.py
@@ -58,7 +58,12 @@ executions = []
 
 class TestMultiprocessIavf(TestCase):
 
-    support_nic = ["ICE_100G-E810C_QSFP", "ICE_25G-E810C_SFP", "ICE_25G-E810_XXV_SFP"]
+    support_nic = [
+        "ICE_100G-E810C_QSFP",
+        "ICE_25G-E810C_SFP",
+        "ICE_25G-E810_XXV_SFP",
+        "ICE_25G-E823C_QSFP",
+    ]
 
     def set_up_all(self):
         """
diff --git a/tests/TestSuite_rxtx_offload.py b/tests/TestSuite_rxtx_offload.py
index 4c084abf..a40bf0b0 100644
--- a/tests/TestSuite_rxtx_offload.py
+++ b/tests/TestSuite_rxtx_offload.py
@@ -78,6 +78,7 @@ class TestRxTx_Offload(TestCase):
                 "cavium_a064",
                 "ICE_25G-E810C_SFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "NIC Unsupported: " + str(self.nic),
         )
@@ -604,6 +605,7 @@ class TestRxTx_Offload(TestCase):
             "cavium_a064",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E823C_QSFP",
         ]:
             self.dut.send_expect("port stop 0", "testpmd> ")
             self.dut.send_expect(
@@ -832,6 +834,7 @@ class TestRxTx_Offload(TestCase):
                 "I40E_10G-10G_BASE_T_X722",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "%s nic not support rx offload setting by queue." % self.nic,
         )
diff --git a/tests/TestSuite_scatter.py b/tests/TestSuite_scatter.py
index 534b3f25..c4b2de23 100644
--- a/tests/TestSuite_scatter.py
+++ b/tests/TestSuite_scatter.py
@@ -57,6 +57,7 @@ class TestScatter(TestCase):
             "I40E_10G-10G_BASE_T_BC",
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E823C_QSFP",
         ]:
             self.mbsize = 2048
         else:
diff --git a/tests/TestSuite_veb_switch.py b/tests/TestSuite_veb_switch.py
index f391a0ee..f87b726f 100644
--- a/tests/TestSuite_veb_switch.py
+++ b/tests/TestSuite_veb_switch.py
@@ -144,6 +144,7 @@ class TestVEBSwitching(TestCase):
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E823C_QSFP",
             ],
             "NIC Unsupported: " + str(self.nic),
         )